<template>
  <div class="q-pa-md">
    <div>
      <h1>  New Domain </h1>

      <div class="row">
        <div class="col-sm-3 col-12">
          <q-input outlined stack-label
                   v-model="domainId"
                   color="indigo-8"
                   label="Domain ID"
                   hint="The abbreviation that identifies a domain in AssureNet. Ex: ppw01, app01, iaa01" />
        </div>

        <div class="col-sm-1 col-12">
        </div>

        <div class="col-sm-3 col-12">
          <q-input  outlined stack-label
                   v-model="domainName"
                    color="indigo-8"
                    label="Domain Name"
                    hint="Customer Name. Ex.: Paddy Power Betfair, APPLUS, Irish Aviation Authority" />
        </div>
      </div>

      <div class="row">
        <div class="col-sm-3 col-12 text-white">
          <span >. </span>
        </div>
      </div>

    </div>

    <div class="actions" align="right" style="max-width: 130px">
        <q-btn color="light-green-4" @click="createDomain">
          <div>Add domain </div>
        </q-btn>
    </div>

    <div class="q-pa-md" style="max-width: 400px">
      <q-table
        title="Existing Domains"
        :separator="separator"
        :columns="domainsTableColums"
        :data="domainsTableData"
        :rows-per-page-options="[15]"
      />
    </div>

  </div>
</template>

<script>
export default {
  data() {
    return {
      separator: 'cell',
      domainId: null,
      domainName: null,
      domainsTableColums: [
        {
          name: "id",
          label: "Domain ID",
          field: "id",
          sortable: true
        },
        {
          name: "name",
          label: "Domain Name",
          field: "name",
          sortable: true
        },
      ],
      domainsTableData: [],
    }
  },
  mounted() {
    this.fetchDomainsData();
  },
  methods: {
    fetchDomainsData(){
      const url = `domains`
      this.$axios.get(url)
        .then(response => {
          this.domainsTableData = response.data;
          console.log(response.data)
        })
        .catch((error) => {
          this.$q.dialog({
            title: 'WARNING!',
            dark: true,
            color: 'red',
            message: error.response.data
          }).onOk(() => {
          })
        })
        .finally(() => {
          this.$q.loading.hide();
        })
    },
    createDomain() {
      this.domainsTableData = [];
      this.$q.loading.show();
      const url = `domains`
      const json = {'id': this.domainId, 'name': this.domainName}
      this.$axios.post(url, json)
        .then(response => {
          this.$q.dialog({
            title: 'Info',
            message: 'Domain registration successful!'
          }).onOk(() => {
          })
        })
        .catch((error) => {
          this.$q.dialog({
            title: 'WARNING!',
            dark: true,
            color: 'red',
            message: error.response.data
          }).onOk(() => {
          })
        })
        .finally(() => {
          this.$q.loading.hide();
          this.domainId = null
          this.domainName = null
          this.fetchDomainsData();
        })
    },
    notify(message, icon = 'check') {
      this.$q.notify({icon, position: 'top', message})
    },
  }
}
</script>

<style lang="stylus">
  h1
    font-size 1.5rem
    line-height 2rem

  h2
    font-size 0.9rem
    line-height 2rem

  .actions
    margin-top 20px

  .info
    background-color rgb(247, 232, 236)

  .q-chip--dense
    font-size 14px
</style>
